
c                                F  E  N   5   

c                                Utilitaires

C-----------------------------------------------------------------------

C  Ceci est une srie de routines qui font partie de Fen 5 puisqu'elles
C   sont utilises par celui-ci pour beaucoup.
C  Cependant elles peuvent tre utilises hors du cadre de Fen 5

      INCLUDE 'fgraph.fi'

c-------------------------------------------------------------------------
c-----Subroutine Graphicsmode pour fixer le mode graphique, ainsi que la 
c     palette de couleurs

c    Les rfrences aux couleurs d'atomes viennent de ce que Fen5 fut
c  cr au dpart pour 'Spacem94',programme de visualisation de molcules 3D.

        SUBROUTINE GraphicsMode ()

        IMPLICIT   none
        INCLUDE   'fgraph.fd'
        INTEGER*2  dummy
        INTEGER*4  rvb
        
        dummy = setvideomode ($VRES16COLOR)             ! VGA 16 couleurs
        IF (dummy .EQ. 0) dummy = setvideomode ($VRES2COLOR) ! monochrome
        IF (dummy .EQ. 0) THEN                            !  tout hasard
          WRITE (*, *) 'ERREUR : impossible de passer en mode graphique'
          STOP  
     &  'Ce programme recquiert une carte VGA 16 couleurs ou suprieure'
        ENDIF

C  Les couleurs sont de Jean-Yves

c-----Etablissement d'une palette de couleurs adapte aux molcules 
c     organiques.
C     (l'indice 0 est le $BLUE (cf setbkcolor))
        dummy = remappalette (1 ,rvb (63, 63, 63)) ! blanc       hydrogne
        dummy = remappalette (2 ,rvb (25, 25, 25)) ! gris          carbone
        dummy = remappalette (3 ,rvb (10, 10, 63)) ! bleu            azote
        dummy = remappalette (4 ,rvb (63, 20, 00)) ! rouge         oxygne
        dummy = remappalette (5 ,rvb (58, 63, 20)) ! jaune-vert      fluor
        dummy = remappalette (6 ,rvb (45, 00, 10)) ! carmin      phosphore
C                  on ne remappe pas l'index 7, c'est le blanc standard,
C                                       couleur par dfaut du mode texte
        dummy = remappalette (8 ,rvb (63, 45, 00)) ! jaune          soufre
        dummy = remappalette (9 ,rvb (00, 63, 20)) ! vert           chlore
        dummy = remappalette (10,rvb (63, 00, 32)) ! fuchsia         brome
        dummy = remappalette (11,rvb (50, 22, 05)) ! brun             iode
        dummy = remappalette (12,rvb (00, 63, 63)) ! cyan  textes de menus
        dummy = remappalette (13,rvb (00, 00, 00)) ! noir
        dummy = remappalette (14,rvb (10, 36, 00)) ! vert           angles
        dummy = remappalette (15,rvb (44, 44, 44)) ! gris tout autre atome
        END

c-----------------------------------------------------------------------       
C     Fonction Rvb, accepte les valeurs de rouge, bleu, vert et les mixe
C     en une valeur de couleur pour remapper une palette.

        INTEGER*4 FUNCTION rvb (r, v, b)

        IMPLICIT  none
        INTEGER*4 r, v, b
        
        RVB = ((256*b .OR. v)*256) .OR. r
        
        END

C-----------------------------------------------------------------------

c-----Subroutine Premiere ; c'est la page de prsentation
c      On la quitte en cliquant

c  NB : 'modern' n'est pas dcharge car le main l'utilise. Si on veut une
c   autre police, penser  rajouter une option qui la dcharge (il est
c   kamikaze de charger plusieurs polices simultanment, ou plusieurs fois
c   la mme) ( attention aux boucles ! )

        SUBROUTINE   premiere

        IMPLICIT     none
        INCLUDE     'fgraph.fd'
        INTEGER*2    delay, m1, m2, m3, m4, dummy, i
        CHARACTER*20 police
        CHARACTER*80 version, titel, auteur1, auteur2, intertitre1
        CHARACTER*80 intertitre2, intertitre3, subject, lieu
        RECORD /xycoord/ s

        titel       = 'Fen 5 Dmo'
        version     = 'v 1.3'
        intertitre1 = 'Oeuvre de :'
        auteur1     = 'Christophe Courtois'
        intertitre2 = 'et de :'
        auteur2     = 'Jean-Yves Rehby'
        lieu        = 'ENSIC Nancy 1994'
        intertitre3 = 'dans le cadre du projet informatique 1A'
        subject     = 
     &       'Interface graphique  menus & fentres en Fortran'
         
C-----Charger la police 'roman' et crire dans cette police tout ce qui 
C     doit l'tre 

        dummy = registerfonts ('roman.fon')
        IF (dummy .LT. 0) GOTO 100           ! si problme
        police = "t'roman'"//'h280w58b'
        dummy = setfont (police)
        IF (dummy .LT. 0) THEN               ! si problme...
          CALL unregisterfonts ()
          GOTO 100
        ENDIF

c Titre en relief
        dummy = setcolor (3)                              !  plat en bleu
        CALL moveto (17, 7, s)
        CALL outgtext (titel) 
                         
        DO i = 1, 8
          dummy = setcolor (2)                        ! une couche de gris
          CALL moveto (18-i, 8-i, s)
          CALL outgtext (titel) 
          dummy = setcolor (3)                     ! et une couche de bleu
          CALL moveto (17-i, 7-i, s)
          CALL outgtext (titel) 
          dummy = delay (0.02)   ! petite pause
        ENDDO

c Numro de version
        police = "t'roman'"//'h10w15b'
        dummy = setfont (police)
        dummy = setcolor (2)                                     ! ombrage
        CALL moveto (14, 256, s)
        CALL outgtext (version)
        dummy = setcolor (3)                                    ! criture 
        CALL moveto (12, 254, s)
        CALL outgtext (version)
        
c Auteurs
        police = "t'roman'"//'h19w14b'
        dummy = setfont (police)
        dummy = setcolor (2)                                     ! ombrage
        CALL moveto (37, 326, s)
        CALL outgtext (auteur1)
        CALL moveto (37, 391, s)
        CALL outgtext (auteur2)
        CALL moveto (37, 456, s)
        CALL outgtext (lieu)
        dummy = setcolor (8)     ! criture
        CALL moveto (35, 324, s)
        CALL outgtext (auteur1)
        CALL moveto (35, 389, s)
        CALL outgtext (auteur2)
        CALL moveto (35, 454, s)
        CALL outgtext (lieu)
        dummy = setcolor (2)       ! ombrage

c Textes entre les noms d'auteur
        police = "t'roman'"//'h19w12b'
        dummy = setfont (police)
        CALL moveto (12, 297, s)
        CALL outgtext (intertitre1) 
        CALL moveto (12, 362, s)
        CALL outgtext (intertitre2)
        CALL moveto (12, 427, s)
        CALL outgtext (intertitre3)
        dummy = setcolor (9)
        CALL moveto (10, 295, s)
        CALL outgtext (intertitre1) 
        CALL moveto (10, 360, s)
        CALL outgtext (intertitre2)
        CALL moveto (10, 425, s)
        CALL outgtext (intertitre3)
        
        CALL unregisterfonts ()
        
C-----On passe  la police 'modern'
 100  CONTINUE
        dummy = registerfonts ('modern.fon')
        IF (dummy .LT. 0) RETURN
        police = "t'modern'"//'h30w10b'
        dummy = setfont (police)
        IF (dummy .LT. 0) THEN
          CALL unregisterfonts ()
          RETURN
        ENDIF
          
        dummy = setcolor (2)
        DO i = 1, 3
          CALL moveto (124-i, 244-i, s)   
          CALL outgtext (subject)
        ENDDO
        dummy = setcolor (9)
        CALL moveto (120, 240, s)   
        CALL outgtext  (subject)
        
c  On attend la pression sur le bouton de la souris
        m1 = 0                                     ! initialiser la souris
        CALL souris (m1, m2, m3, m4)
        CALL allumers
 200  CONTINUE
        CALL activers (m1, m2, m3, m4)
        IF (m2 .NE. 1) GOTO 200
        CALL relax (m3, m4)
        CALL eteindres
        
        END

C-----------------------------------------------------------------------
        
        INTEGER*2 FUNCTION delay (duree)

C-----Fonction delay : effectue un boucle de temps, avec sortie quand 
C       dure secondes sont passes
C     (Rappel : mme programms sur 386, les projets 1A ENSIC sont
C       prsents sur 486, et donc il vaut mieux utiliser delay qu'une
C       boucle vide d'attente qui dpendrait de l'ordinateur)

C  Cette fonction a t trouve dans le source du vieux Spacem

        IMPLICIT  none
        
        REAL      duree                       ! Dclaration des paramtres
                                                        
        INTEGER*2 ihr, imin, isec, i100th              !   Dclaration des 
        REAL*8    nbsec, origine, delta                ! variables locales

        CALL gettim (ihr, imin, isec, i100th)    ! Rcupration de l'heure

C-----Calcul du nombre de secondes  partir de minuit
        origine = DBLE (ihr)*3600 + DBLE (imin)*60 + DBLE (isec)
     &        + DBLE (i100th)/100
        delta = 0
        DO WHILE (delta .LT. duree)
           CALL gettim (ihr, imin, isec, i100th)
           nbsec = DBLE (ihr)*3600 + DBLE (imin)*60 + DBLE (isec)
     &         + DBLE (i100th)/100
           delta = nbsec-origine           ! Calcul de la dure en seconde
        ENDDO
        delay = 0

        END

C-----------------------------------------------------------------------

        SUBROUTINE    centro (yy, chaine, largo)

c   Centro est une routine qui centre la chane envoye sur la ligne yy 
c   de l'cran. Il faut prciser largo, qui est la largeur de la fentre 
c   d'affichage (en colonnes texte). Si largo <= 0, il est pass d'offi-
c   ce  80 colonnes. On obtiendra une abscisse >= 1 ; attention aux 
c   chanes trop longues.

        IMPLICIT      none
        INCLUDE      'fgraph.fd'
        CHARACTER*(*) chaine
        INTEGER       xx, yy, longch        ! ncessite la fonction longch
        INTEGER       largo

        IF (largo .LE. 0) largo = 80
        xx = (largo - longch (chaine))/2              ! calcule l'abscisse
        IF (xx .LE. 0) xx = 1                                  !   xx >= 1
        CALL texto (yy, xx, chaine)                            ! affichage

        END
C-----------------------------------------------------------------------

        SUBROUTINE       texto (yy, xx, chaine)

c   La subroutine texto affiche caractre par caractre, soigneusement  
c   l'endroit spcifi.
c   Elle remplace settextposition et outtext et vite les dbordements 
c   de la chane  afficher sur le reste (espaces excdentaires en bout 
c   de chane).

c Attention : quand on transmet 1 chane d'1 caractre, le rsultat est
c  bizarre; est-ce li  longch ?? (rsolution apparente du problme en 
c  remplaant chaine = '#' par chaine = '# ' (avec un espace !))

        IMPLICIT         none
        INCLUDE         'fgraph.fd'

        CHARACTER*(*)    chaine
        INTEGER          xx, yy, i, longch  ! ncessite la fonction longch
        RECORD /xycoord/ xy                

        DO i = 1, longch (chaine)+1
          CALL settextposition (yy, xx+i, xy)
          CALL outtext (chaine (i:i))
        ENDDO

        END

c-----------------------------------------------------------------------
     
        FUNCTION longch (chaine)

c-----Renvoie la longueur REELLE d'une chane
c----( attention, est peut-tre bogue pour une chane d'une lettre,
c---- cf avertissement dans texto )

        INTEGER       longch, lt, c
        CHARACTER*(*) chaine

        lt = len (chaine)          
        longch = lt

        c = ICHAR (chaine (lt:lt))
        DO WHILE (.NOT. (c .GT. 32))
c.... Diminue longch tant qu'il trouve des espaces en bout de chane
          longch = longch-1
          c = ICHAR (chaine (longch:longch))
        ENDDO

        END
          
c-----------------------------------------------------------------------

        SUBROUTINE     geti (integ, wg)

c  La subroutine Geti renvoie : 
c  un integer saisi au clavier dans integ et wg = .FALSE. 
c  En cas de saisie rate (saisie vide, chaine de caractres...) elle 
c  renvoie :
c  integ = 0 et wg = .TRUE.

        IMPLICIT       none
        INTEGER        integ
        REAL           float
        LOGICAL        wg
        
        integ = 0
        CALL getf (float, wg)
        IF (wg) RETURN
        integ = int (float)
        END


c-----------------------------------------------------------------------

        SUBROUTINE     getf (float, wg)

c  La subroutine Getf renvoie : 
c  un real saisi au clavier dans float et wg = .FALSE. 
c  En cas de saisie rate (saisie vide, chaine de caractres...) elle 
c  renvoie :
c  float = 0 et wg = .TRUE.

c  (Accessoirement elle rpond aux petits messages que peuvent lui sussurer
c  certains professeurs d'informatique de l'ENSIC...)(libre  vous de
c  rajouter des cas diffrents...)

        IMPLICIT       none
        INTEGER        plante
        REAL           float
        LOGICAL        wg
        CHARACTER*30   chaine
                            
        wg = .FALSE.
        float = 0.0

        READ (*, '(a)', err = 9999, iostat = plante) chaine
        IF (plante .NE. 0) GOTO 9999

c  Scurits anti - prof ENSIC

        IF (    index (chaine, 'onjour') .GT. 0) THEN
          CALL ShortAlertBox ('Bonjour !', ' ','OK ', ' ', 1)
          GOTO 9999
        ELSEIF (index (chaine, 'anane') .GT. 0) THEN
          CALL Shortalertbox 
     &                   ('C''est bon les bananes !', ' ', 'OK', ' ', 1)
          GOTO 9999
        ELSEIF (index (chaine, 'oncombre') .GT. 0) THEN
          CALL Shortalertbox 
     &               ('J''aime pas les concombres !', ' ', 'OK', ' ', 1)
          GOTO 9999
        ELSEIF (index (chaine,'erde').GT.0) THEN
          CALL ShortAlertBox
     &        ('Je vous serai gr de rester poli',' ','Mille mercis',
     &         ' ',1)
          GOTO 9999
        ENDIF
             
c Fin des dlires

        READ (chaine, '(f10.0)', err = 9999, iostat = plante) float
        IF (plante .NE. 0) GOTO 9999

        RETURN
 
 9999 wg = .TRUE.

        END

C ************************ FIN DE FEN 5 UTIL ****************************


